## 折叠面板

### 默认展开

```html
<template>
  <cl-collapse :openDefault="['more']" accordion>
    <cl-collapse-item name="basic">
      <template slot="title">
        <cl-icon name="user" />
        基本信息
      </template>
      <cl-h1>基本信息</cl-h1>
    </cl-collapse-item>
    <cl-collapse-item title="更多信息" name="more">
      <cl-h1>更多信息</cl-h1>
    </cl-collapse-item>
  </cl-collapse>
</template>
<!-- collapse-1.vue -->
```

### 折叠时校验

```html
<template>
  <el-form ref="form" :model="form">
    <cl-collapse :openDefault="['more']" accordion is-verify>
      <cl-collapse-item name="basic">
        <template slot="title">
          <cl-icon name="user" />
          基本信息
        </template>
        <cl-form-item label="姓名">
          <cl-input v-model="form.name" validate="required" />
        </cl-form-item>
      </cl-collapse-item>
      <cl-collapse-item title="更多信息" name="more">
        <cl-form-item label="年龄">
          <cl-input v-model="form.age" validate="required" />
        </cl-form-item>
        <cl-form-item label="性别">
          <cl-radio
            v-model="form.sex"
            validate="required"
            :options="[
              { key: '1', value: '男士' },
              { key: '2', value: '女士' },
            ]"
          />
        </cl-form-item>
      </cl-collapse-item>
    </cl-collapse>
  </el-form>
</template>
<script>
  export default {
    data() {
      return {
        form: {
          name: "",
          age: "",
          sex: "",
        },
      };
    },
  };
</script>

<!-- collapse-2.vue -->
```


### Collapse Attributes
| 参数      | 说明          | 类型      | 可选值                           | 默认值  |
|---------- |-------------- |---------- |--------------------------------  |-------- |
| open-default | 当前激活的面板(如果是手风琴模式，则需要数组中值为一个，否则为会默认展开多个面板) | array | — | — |
| accordion | 是否手风琴模式 | boolean | — | false |

### Collapse Events
| 事件名称 | 说明 | 回调参数 |
|---------|---------|---------|
| change | 当前激活面板改变时触发(如果是手风琴模式，参数 `activeNames` 类型为`string`，否则为`array`) | (activeNames: array / string) |

### Collapse Item Attributes
| 参数      | 说明          | 类型      | 可选值                           | 默认值  |
|---------- |-------------- |---------- |--------------------------------  |-------- |
| name      | 唯一标志符      | string/number | —     | —    |
| title     | 面板标题        | string        | —     | —    |
| disabled  | 是否禁用        | boolean       | —     | —    |
