## 数据字典

### 基础用法

```html
<template>
  <div>
    <el-radio-group
      v-model="permission"
      size="small"
      style="margin-bottom: 20px"
    >
      <el-radio-button label="n">无权限</el-radio-button>
      <el-radio-button label="r">只读</el-radio-button>
      <el-radio-button label="w">编辑</el-radio-button>
      <el-radio-button label="b">必填</el-radio-button>
    </el-radio-group>
    <br />
    <cl-dictionary
      v-model="sjzd"
      :permission="permission"
      dickey="xmlx"
      filterable
    />
  </div>
</template>
<script>
  export default {
    data() {
      return {
        sjzd: "",
        permission: "w",
      };
    },
  };
</script>

<!-- dictionary-1.vue -->
```

### Dictionary Attributes

| 参数          | 说明            | 类型            | 可选值                 | 默认值   |
|-------------  |---------------- |---------------- |---------------------- |-------- |
| placeholder   | 输入框占位文本   | string          | — | — |
| disabled      | 禁用            | boolean         | — | false   |
| popper-class | Dictionary 下拉列表的类名 | string | — | — |
| dickey | 数据字典的key | string | - | - |
| clearable | 是否有清空按钮 | boolean | - | true |
| filterable | 是否支持搜索过滤 | boolean | - | false |
