## 分割线

### 基础用法

```html
<template>
  <div>
    <span>青春是一个短暂的美梦, 当你醒来时, 它早已消失无踪</span>
    <cl-divider></cl-divider>
    <span>少量的邪恶足以抵消全部高贵的品质, 害得人声名狼藉</span>
  </div>
</template>

<!-- divider-1.vue -->
```


### 设置文案

```html
<template>
  <div>
    <span>头上一片晴天，心中一个想念</span>
    <cl-divider content-position="left">少年包青天</cl-divider>
    <span>饿了别叫妈, 叫饿了么</span>
    <cl-divider><cl-icon name="component" /></cl-divider>
    <span>为了无法计算的价值</span>
    <cl-divider content-position="right" color="red">阿里云</cl-divider>
  </div>
</template>

<!-- divider-2.vue -->
```

### 垂直分割

```html
<template>
  <div>
    <span>雨纷纷</span>
    <cl-divider direction="vertical"></cl-divider>
    <span>旧故里</span>
    <cl-divider direction="vertical"></cl-divider>
    <span>草木深</span>
  </div>
</template>

<!-- divider-3.vue -->
```

### Divider Attributes
| 参数          | 说明            | 类型            | 可选值                 | 默认值   |
|-------------  |---------------- |---------------- |---------------------- |-------- |
| direction      | 设置分割线方向  | string  |            horizontal / vertical          |    horizontal     |
| content-position      | 设置分割线文案的位置 | string  |  left / right / center  |  center |
| color | 设置线条颜色 | string | - | `#dcdfe6` |
