## 里程碑

### 基础用法

```html
<template>
  <el-form label-width="120px">
    <cl-form-item label="权限">
      <el-radio-group v-model="permissionVal">
        <el-radio label="n">无权限</el-radio>
        <el-radio label="r">只读</el-radio>
        <el-radio label="w">编辑</el-radio>
        <el-radio label="b">必填</el-radio>
      </el-radio-group>
    </cl-form-item>
    <cl-form-item label="里程碑">
      <cl-milepost
        v-model="mileVal"
        direction="horizontal"
        :permission="permissionVal"
        content='[{"title":"需求调研","description":"需求分析阶段"},{"title":"系统设计","description":"系统设计阶段"},{"title":"编码实现","description":"编码实现阶段"}]'
      ></cl-milepost>
    </cl-form-item>
    <cl-form-item>
      <template slot="label">
        <span v-tooltip="'设置当前里程碑激活的阶段，1：激活第一个阶段，2：激活第二个阶段，以此类推...'">里程碑值</span>
      </template>
      <cl-input v-model="mileVal" />
    </cl-form-item>
  </el-form>
</template>
<script>
  export default {
    data() {
      return {
        permissionVal: "w",
        mileVal: "1",
      };
    },
  };
</script>

<!-- milepost-1.vue -->
```
