const navAry = [
  {
    name: '更新日志',
    icon: '',
    path: '/changelog',
  },
  {
    name: '开发指南',
    icon: '',
    children: [
      {
        name: '安装',
        icon: 'setting',
        path: '/installation',
      },
      {
        name: '开发注意事项',
        icon: 'bookmark',
        path: '/standard',
      },
    ],
  },
  {
    name: '组件',
    icon: '',
    children: [
      {
        name: 'Basic',
        children: [
          {
            name: '图标',
            icon: 'component',
            path: '/icon',
          },
          {
            name: '常用图标',
            path: '/icons',
            icon: 'book',
            component: () => import('$exp/components/Icon.vue'),
          },
          {
            name: '文字',
            icon: 'typography',
            path: '/typography',
          },
        ],
      },
      {
        name: 'Layout',
        children: [
          {
            name: '折叠面板',
            icon: 'collapseItem',
            path: '/collapse',
          },
          {
            name: '分页布局',
            icon: 'step',
            path: '/step',
          },
          {
            name: 'tabs布局',
            icon: 'tabs',
            path: '/tabs',
          },
          {
            name: '分割线',
            icon: 'divider',
            path: '/divider',
          },
        ],
      },
      {
        name: 'Form',
        children: [
          {
            name: '输入建议',
            icon: 'autocomplete',
            path: '/autocomplete',
          },
          {
            name: '级联',
            icon: 'ganged',
            path: '/cascader',
          },
          {
            name: '数据字典',
            path: '/dictionary',
          },
          {
            name: '输入框',
            icon: 'input',
            path: '/input',
          },
          {
            name: '单选框',
            icon: 'radio',
            path: '/radio',
          },
          {
            name: '复选框',
            icon: 'checkbox',
            path: '/checkbox',
          },
          {
            name: '下拉框',
            icon: 'select',
            path: '/select',
          },
          {
            name: '日期',
            icon: 'date',
            path: '/date',
          },
          {
            name: '时间',
            icon: 'time',
            path: '/time',
          },
          {
            name: '富文本',
            icon: 'ganged',
            path: '/editor',
          },
          {
            name: '附件',
            icon: 'attachment',
            path: '/attachment',
          },
          {
            name: '时长',
            icon: 'duration',
            path: '/duration',
          },
          {
            name: '开关',
            icon: 'switch',
            path: '/switch',
          },
          {
            name: '标签',
            icon: 'tag',
            path: '/tag',
          },
          {
            name: '表单',
            icon: 'form',
            path: '/form',
          },
          {
            name: '在线表单',
            icon: 'form',
            path: '/online',
          },
        ],
      },
      {
        name: 'Data',
        children: [
          {
            name: '表格',
            icon: 'table',
            path: '/table',
          },
          {
            name: '更多表格',
            icon: 'table',
            path: '/table2',
          },
          {
            name: '树',
            icon: 'tree',
            path: '/tree',
          },
          {
            name: '在线预览',
            icon: 'eye',
            path: '/preview',
          },
          {
            name: '图表',
            icon: 'chart',
            path: '/chart',
          },
          {
            name: '表单列表',
            icon: 'table',
            path: '/dataView',
          },
          {
            name: '表单列表编辑页',
            icon: 'table',
            path: '/templateForm',
          },
          {
            name: '相关流程',
            icon: 'flow',
            path: '/relevantFlow',
          },
          {
            name: '里程碑',
            icon: 'milepost',
            path: '/milepost',
          },
        ],
      },
      {
        name: 'Other',
        children: [
          {
            name: '按钮',
            icon: 'button',
            path: '/button',
          },
          {
            name: '对话框',
            icon: 'dialog',
            path: '/dialog',
          },
          {
            name: '背景图片',
            icon: 'image',
            path: '/image',
          },
          {
            name: '图片',
            icon: 'image',
            path: '/picture',
          },
          {
            name: '地图',
            icon: 'map',
            path: '/map',
          },
          {
            name: '二维码',
            icon: 'qrcode',
            path: '/qrcode',
          },
          {
            name: '评分',
            icon: 'rate',
            path: '/rate',
          },
          {
            name: '滑块',
            icon: 'slider',
            path: '/slider',
          },
        ],
      },
    ],
  },
  {
    name: '特性',
    icon: '',
    children: [
      {
        name: '国际化',
        icon: 'global',
        path: '/i18n',
      },
      {
        name: '校验',
        icon: 'validation',
        path: '/validation',
      },
      {
        name: '计算公式',
        path: '/math',
        icon: 'calc',
      },
      {
        name: '联动',
        path: '/linkage',
        icon: 'ganged',
      },
      {
        name: '指令',
        path: '/directive',
        icon: 'laptop',
      },
      {
        name: '工具方法',
        icon: 'tools',
        path: '/tools',
      },
    ],
  },
]

export default navAry
