import Vue from 'vue'
import Router from 'vue-router'
import navAry from './nav.config'

Vue.use(Router)

const routes = [
  {
    path: '/',
    redirect: {
      path: '/installation',
    },
  },
]

const routeRegister = (ary) => {
  ary.forEach((nav) => {
    const { path, children } = nav
    if (path) {
      routes.push({
        path: path,
        component: nav.component
          ? nav.component
          : () => import(`$exp/docs${nav.path}.md`),
        meta: { icon: nav.icon },
      })
    }
    if (children && children.length > 0) {
      routeRegister(children)
    }
  })
}

routeRegister(navAry)

var router = new Router({
  mode: 'history', // hash  history
  base: process.env.BASE_URL,
  routes,
})

export default router
