import '@/directive/index'
import '@/filter/index'
import validate from '@/validate'
import ClInput from '../packages/Input/index'
import ClCheckbox from '../packages/Checkbox/index'
import ClTable from '../packages/Table/index'
import ClTableColumn from '../packages/TableColumn/index'
import ClTableSearchPanel from '../packages/TableSearchPanel/index'
import ClTableSearchField from '../packages/TableSearchField/index'
import ClRadio from '../packages/Radio/index'
import ClDate from '../packages/Date/index'
import ClTimeSelect from '../packages/TimeSelect/index'
import ClTimePicker from '../packages/TimePicker/index'
import ClSelect from '../packages/Select/index'
import ClFile from '../packages/File/index'
import ClDemension from '../packages/Demension/index'
import ClTree from '../packages/Tree/index'
import ClAddQueryStrategy from '../packages/AddQueryStrategy/index'
import ClSidebarDialog from '../packages/SidebarDialog/index'
import Selector from '../packages/Selector/index'
import ClRoleSelector from '../packages/RoleSelector/index'
import ClUserSelector from '../packages/UserSelector/index'
import ClOrgSelector from '../packages/OrgSelector/index'
import ClJobSelector from '../packages/JobSelector/index'
import ClPostSelector from '../packages/PostSelector/index'
import ClDimensionSelector from '../packages/DimensionSelector/index'
import ClUserDialog from '../packages/UserDialog/index'
import ClDialog from '../packages/Dialog/index'
import ClCustomDialog from '../packages/CustomDialog/index'
import ClOrgPostDialog from '../packages/OrgPostDialog/index'
import ClTreeDialog from '../packages/TreeDialog/index'
import ClTreeListDialog from '../packages/TreeListDialog/index'
import ClFormItem from '../packages/FormItem/index'
import ClSaveButton from '../packages/SaveButton/index'
import ClDuration from '../packages/Duration/index'
import ClFieldTail from '../packages/FieldTail/index'
import ClFileUpload from '../packages/FileUpload/index'
import ClIcon from '../packages/Icon/index'
import ClEditor from '../packages/Editor/index'
import ClPicture from '../packages/picture/index'
import ClExplain from '../packages/Explain/index'
import {
  ClH1,
  ClH2,
  ClH3,
  ClH4,
  ClH5,
  ClH6,
} from '../packages/Typography/index'
import '../packages/Icon/src/icons'
import locale from '@/locale'
import { version } from '../package.json'

/** sp1-control */
import ClCollapse from '../packages/Collapse/index'
import ClCollapseItem from '../packages/CollapseItem/index'
import ClStep from '../packages/Step/index'
import ClSteps from '../packages/Steps/index'
import ClStepLayout from '../packages/StepLayout/index'
import ClDivider from '../packages/Divider/index'
import ClTabs from '../packages/Tabs/index'
import ClAutocomplete from '../packages/Autocomplete/index'
import ClCascader from '../packages/Cascader/index'
import ClDatePicker from '../packages/DatePicker/index'
import ClDictionary from '../packages/Dictionary/index'
import ClReadonlyInput from '../packages/ReadonlyInput/index'
import ClOnlineForm from '../packages/OnlineForm/index'
import ClUserSelectorInput from '../packages/UserSelectorInput/index'
import ClOrgSelectorInput from '../packages/OrgSelectorInput/index'
import ClRoleSelectorInput from '../packages/RoleSelectorInput/index'
import ClPostSelectorInput from '../packages/PostSelectorInput/index'
import ClJobSelectorInput from '../packages/JobSelectorInput/index'
import ClDimensionSelectorInput from '../packages/DimensionSelectorInput/index'
import ClSwitch from '../packages/Switch/index'
import ClTag from '../packages/Tag/index'
import ClSelectTree from '../packages/SelectTree/index'
import ClButton from '../packages/Button/index'
import ClImage from '../packages/Image/index'
import ClChart from '../packages/Chart/index'
import ClMap from '../packages/Map/index'
import ClQrcode from '../packages/Qrcode/index'
import ClDataView from '../packages/DataView/index'
import ClRelevantFlow from '../packages/RelevantFlow/index'
import ClMilepost from '../packages/Milepost/index'
import ClText from '../packages/Text/index'
import ClRate from '../packages/Rate/index'
import ClSlider from '../packages/Slider/index'
import ClTemplateForm from '../packages/TemplateForm/index'
import ClTemplateBatchUpdateDialog from '../packages/TemplateBatchUpdate/index'
import ClTemplateFormDialog from '../packages/TemplateFormDialog/index'
import FlowChart from '../packages/FlowChart/index'
import ProcessRecord from '../packages/ProcessRecord/index'
import TemplateImportResult from '../packages/TemplateImportResult/index'
import TemplateTaskCirculate from '../packages/TemplateTaskCirculate/index'
import {
  GlobalValidate as ClGlobalValidate,
  GlobalQuery as ClGlobalQuery,
} from '../packages/Global/index'
import {
  SubDialog as ClSubDialog,
  SubtableBackfill as ClSubtableBackfill,
  SubPagination as ClSubPagination,
  SubExportDialog as ClSubExportDialog,
  SubImportDialog as ClSubImportDialog,
} from '../packages/Subtable/index'

import {
  TemplatePreview as ClTemplatePreview,
  TemplatePreviewFile as ClTemplatePreviewFile,
  TemplatePreviewImage as ClTemplatePreviewImage,
} from '../packages/TemplatePreview/index'

import ClQuerySqlPreview from '../packages/QuerySqlPreview/index'

const SwordUi = {
  version,
  ClInput,
  ClCheckbox,
  ClRadio,
  ClDate,
  ClTimeSelect,
  ClTimePicker,
  ClTable,
  ClTableColumn,
  ClTableSearchPanel,
  ClTableSearchField,
  ClSelect,
  ClFile,
  ClDemension,
  ClTree,
  ClAddQueryStrategy,
  ClSidebarDialog,
  Selector,
  ClRoleSelector,
  ClUserSelector,
  ClOrgSelector,
  ClJobSelector,
  ClPostSelector,
  ClDimensionSelector,
  ClFormItem,
  ClSaveButton,
  ClUserDialog,
  ClDialog,
  ClCustomDialog,
  ClTreeDialog,
  ClTreeListDialog,
  ClOrgPostDialog,
  ClDuration,
  ClFieldTail,
  ClFileUpload,
  ClIcon,
  ClEditor,
  ClH1,
  ClH2,
  ClH3,
  ClH4,
  ClH5,
  ClH6,
  ClCollapse,
  ClCollapseItem,
  ClStep,
  ClSteps,
  ClStepLayout,
  ClDivider,
  ClTabs,
  ClAutocomplete,
  ClCascader,
  ClDatePicker,
  ClDictionary,
  ClReadonlyInput,
  ClOnlineForm,
  ClUserSelectorInput,
  ClOrgSelectorInput,
  ClRoleSelectorInput,
  ClPostSelectorInput,
  ClJobSelectorInput,
  ClDimensionSelectorInput,
  ClSwitch,
  ClTag,
  ClSelectTree,
  ClButton,
  ClImage,
  ClChart,
  ClMap,
  ClQrcode,
  ClDataView,
  ClTemplatePreview,
  ClTemplatePreviewFile,
  ClTemplatePreviewImage,
  ClRelevantFlow,
  ClMilepost,
  ClText,
  ClRate,
  ClSlider,
  ClTemplateForm,
  ClTemplateBatchUpdateDialog,
  ClGlobalValidate,
  ClGlobalQuery,
  ClSubDialog,
  ClSubtableBackfill,
  ClSubPagination,
  ClSubExportDialog,
  ClSubImportDialog,
  ClQuerySqlPreview,
  ClTemplateFormDialog,
  ClPicture,
  FlowChart,
  ProcessRecord,
  ClExplain,
  TemplateImportResult,
  TemplateTaskCirculate,
}

SwordUi.install = (Vue, opts = {}) => {
  if (!opts.smallScreenDialog) {
    opts.smallScreenDialog = false
  }
  if (!opts.paginationBackground) {
    opts.paginationBackground = false
  }
  if (!opts.readonlyInput) {
    opts.readonlyInput = false
  }
  if (!opts.hideTip) {
    opts.hideTip = false
  }
  if (!opts.requestConfig) {
    opts.requestConfig = {}
  }
  Vue.prototype.$smallScreenDialog = opts.smallScreenDialog
  Vue.prototype.$paginationBackground = opts.paginationBackground
  Vue.prototype.$readonlyInput = opts.readonlyInput
  Vue.prototype.$hideTip = opts.hideTip
  Vue.prototype.$requestConfig = opts.requestConfig
  Vue.prototype.$SWORD = {
    size: opts.size || 'small',
  }
  locale.use(opts.locale)
  locale.i18n(opts.i18n)
  Vue.use(validate)

  Object.keys(SwordUi).forEach((name) => {
    const component = SwordUi[name]
    component && component.name && Vue.component(component.name, component)
  })

  Vue.component('cl-vnode', {
    functional: true,
    render: (h, ctx) => {
      // 复制父组件的属性到子组件中
      let assembly = {
        ...ctx.props.vnode.componentOptions.propsData,
        ...ctx.props,
      }
      delete assembly['vnode']
      ctx.props.vnode.componentOptions.propsData = assembly
      ctx.props.vnode.componentOptions.listeners = ctx.listeners
      return ctx.props.vnode
    },
  })
}

if (typeof window !== 'undefined' && window.Vue) {
  SwordUi.install(window.Vue)
}

export default SwordUi
