import utils from '@/utils.js'
import { t } from '@/locale'

// 组件的name属性
export default {
  props: {
    name: String,
    modelName: String,
    size: {
      type: String,
      validator(val) {
        return ['large', 'medium', 'small', 'mini'].includes(val)
      },
    },
    placeholder: {
      type: String,
      default() {
        return t('cl.common.enter')
      },
    },
  },
  computed: {
    inputSize() {
      return this.size || this.$SWORD.size
    },
    inputName: function() {
      return this.name ? `${this.name}__${utils.getName()}` : utils.getName()
    },
  },
}
